(*
 *  beware IRC services, b_burst.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit b_burst;

interface

uses
  buser,bcmds,bstuff,bconsts;

procedure m_burst(cptr,sptr:tuser;parc:integer;parv:pparams);

implementation

uses
  bchannel,btime,bserver,sysutils,blinklist,bcrash,bparse;

{
SENDER  #channel TS +modes USERS :%bans
0       1        2

}

procedure m_burst(cptr,sptr:tuser;parc:integer;parv:pparams);
var
  ch:tchannel;
  clearlocal,ignore,bool:boolean;
  count,a,b,c,d:integer;
  us:tuser;
  uc:tuserchan;
  s,s2:string;

  modestr,modestr2:string;
  ban:tban;
begin
  if (parv[2] = '') or (parc < 3) then exit;
  if parv[1,1] = '&' then exit;
  if not validchanname(parv[1]) then exit;

  a := strtointdef(parv[2],0);

  parv[1] := copy(parv[1],1,maxchanname);
  ch := findchan(parv[1]);
  if ch = nil then begin
    ch := createchannel;
    setchanname(ch,parv[1]);
    if parv[1,1] = '+' then begin
      setflag(ch.flags,chanflag_modeless);
      setflag(ch.modeflag,chanmode_noexternal or chanmode_topic);
      a := 0;
    end;
  end;
  clearlocal := false;
  if not flag_isset(me.server.flags,servflag_ulined) then begin
    if (ch.ts < OLDEST_TS) and (a >= OLDEST_TS) then clearlocal := true
    else if (ch.ts > a) and (a >= OLDEST_TS) then clearlocal := true;
  end;
  ignore := false;
  if not flag_isset(sptr.server.flags,servflag_ulined) then begin
    if (a < OLDEST_TS) and (ch.ts >= OLDEST_TS) then ignore := true
    else if (a > ch.ts) and (ch.ts >= OLDEST_TS) then ignore := true;
  end;

  if not flag_isset(ch.flags,chanflag_modeless) then begin
    bool := false;
    if (ch.ts < OLDEST_TS) and (a >= OLDEST_TS) then bool := true
    else if (ch.ts > a) and (a >= OLDEST_TS) then bool := true;
    if bool then ch.ts := a;
  end;

  modestr := '';
  modestr2 := '';

  if clearlocal then begin
    {clear modes}
    ch.limit := 0;
    ch.key := '';
    ch.modeflag := 0;

    {clear ops/voice}
    uc := tuserchan(ch.user);
    while uc <> nil do begin
      if flag_isset(uc.us.modeflag,usermode_service) then begin
        {if service looses op on burst, re-op}
        uc.flags := uc.flags and not userchanflag_voice;
        if flag_isset(uc.flags,userchanflag_op) then send(me.idstr+' '+TOK_MODE+' '+ch.name+' +o '+uc.us.idstr);
      end else begin
        uc.flags := uc.flags and not (userchanflag_op or userchanflag_voice);
      end;
      uc := tuserchan(uc.next2);
    end;

    while ch.banlist <> nil do begin
      ban := tban(ch.banlist);
      linklistdel(tlinklist(ch.banlist),tlinklist(ch.banlist));
      ban.destroy;
    end;

  end;

  count := 2;
  while count < parc do begin
    if parv[count] = '' then break;
    if parv[count,1] = '+' then begin
      {modes}
      b := count;
      if ignore then begin
        if pos('k',parv[b]) <> 0 then inc(count);
        if pos('l',parv[b]) <> 0 then inc(count);
      end else begin
        for a := 1 to length(parv[b]) do begin
          for c := 0 to maxchanmodetable do if parv[b,a] = chanmodetable[c].c then setflag(ch.modeflag,chanmodetable[c].flag);

          if parv[b,a] = 'l' then begin
            inc(count);
            ch.limit := strtointdef(parv[count],0);
          end;
          if parv[b,a] = 'k' then begin
            inc(count);
            ch.key := parv[count];
          end;
        end;
      end;
    end else if parv[count,1] = '%' then begin
      {bans and end of line}
      if not ignore then begin
        a := 1;
        s2 := copy(parv[count],2,500);
        repeat
          strtok2(s2,' ',a,s);
          if s = '' then break;
          if findban(ch,s) = nil then addban(sptr,ch,s);
        until false;
      end;
      count := parc;
    end else begin
      {users}
      {check if the user exists and us.from = sptr.from;
      if not, dont add.
      if ignore, add but dont set ops/voice}
      a := 1;
      c := 0;
      s2 := parv[count];
      repeat
        strtok2(s2,',',a,s);
        if s = '' then break;
        d := pos(':',s);
        if d <> 0 then begin
          us := findnumeric(copy(s,1,d-1));
          s := copy(s,d+1,100);
          c := 0;
          if not ignore then begin
            if pos('o',s) <> 0 then c := c or userchanflag_op;
            if pos('v',s) <> 0 then c := c or userchanflag_voice;
          end;
        end else begin
          us := findnumeric(s);
        end;
        if us <> nil then begin
          assert(isclient(us),'parse: burst: server tries to join',ch.name+' '+parv[count]);
          uc := addusertochannel(us,ch);
          uc.flags := c;
        end;
      until false;
    end;
    inc(count);
  end;
  if ch.usercount = 0 then ch.destroy;
end;

end.
