{lsocket.pas}

{io core originally for linux bworld}

{use this code for whatever you like in programs under whater licence you like
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
}

// recent changes:
// moved code from close into new procedure internalclose which takes an error
// procedure close now calls internalclose with parameter 0
// sendflush now returns the result of the fdwrite
// made background sending code more solid if a send because of a trigger on
// write deosn't send anything the socket closes
// got rid of the stub sendflush in tlasin as it was no longer needed
// used internalclose wherever there is a error to report for a close
// sendflush now unsets the FD in fdsw this is in case an event handler for
// a socket flushes a socket later in the list
// moved fdsr and fdsw up to global variables so that sendflush can use them
// sendflush now exits immidiately if the socket is not connected

unit lsocket;

interface
  uses sysutils,linux,sockets,inet,classes,pgdebugout,pgtypes;

  type
    FDSet= Array [0..31] of longint;
    PFDSet= ^FDSet;
  const

    absoloutemaxs=(sizeof(fdset)*8)-1;
  type
    ESocketException   = class(Exception);
    TBgExceptionEvent  = procedure (Sender : TObject;
                                  E : Exception;
                                  var CanClose : Boolean) of object;
    TSocketState       = (wsInvalidState,
                        wsOpened,     wsBound,
                        wsConnecting, wsConnected,
                        wsAccepting,  wsListening,
                        wsClosed);
    // note : tsocketstate is defined in the same way as it is in Franois PIETTE's twsocket
    // however tlsocket currently only uses wsClosed wsConnecting wsconnected and wsListen3ing
    TSocketevent     = procedure(Sender: TObject; Error: word) of object;
    //Tdataavailevent  = procedure(data : string);
    TLasin = class
      state              : tsocketstate    ;
      S                  : Longint         ;  {file discriptor}
      onsessionclosed    : tsocketevent    ;
      ondataAvailable    : tsocketevent    ;
      onsessionAvailable : tsocketevent    ;

      onsessionconnected : tsocketevent    ;
      ontimer            : procedure       ;
      //connected          : boolean         ;
      nextasin           : tlasin        ;
      released           : boolean         ;
      prevasin           : tlasin        ;
      tag                : taddrint         ;
      receivestr         : string          ;
      OnBgException      : TBgExceptionEvent;
      procedure close;
      procedure internalclose(error:word); virtual;
      constructor create;
      destructor destroy; override;
      procedure release;
      procedure HandleBackGroundException(E: Exception);

    end;
    TLsocket = class(TLasin)
      //a: string;
      inAddr             : TInetSockAddr   ;
      host               : THost           ;
      sendq              : string          ;



      //mainthread         : boolean         ; //for debuggin only
      addr:string;
      port:string;
      proto:string;
      procedure connect;
      procedure sendstr(str : string);
      procedure putstringinsendbuffer(newstring : string);
      function sendflush : integer;
      //procedure messageloop;
      procedure dup(invalue:longint);
      procedure listen;
      function accept : longint;
      procedure internalclose(error:word);override;
    end;
    tsocket=longint; // for compatibility with twsocket
var
  firstasin : tlasin;
  prevtime           : integer         ;
  FDSR,FDSW  : fdset;
procedure messageloop;
implementation
var
  maxs: longint;
//uses bservunit;
Procedure FD_Clr(fd:longint;var fds:fdSet);inline;
{
  Remove fd from the set of filedescriptors
}
begin
  fds[fd shr 5]:=fds[fd shr 5] and (not (1 shl (fd and 31)));
end;

Procedure FD_Zero(var fds:fdSet);
{
  Clear the set of filedescriptors
}
begin
  FillChar(fds,sizeof(fdSet),0);
end;

Procedure FD_Set(fd:longint;var fds:fdSet);inline;
{
  Add fd to the set of filedescriptors
}
begin
  fds[fd shr 5]:=fds[fd shr 5] or (1 shl (fd and 31));
end;



Function FD_IsSet(fd:longint;var fds:fdSet):boolean;inline;
{
  Test if fd is part of the set of filedescriptors
}
begin
  FD_IsSet:=((fds[fd shr 5] and (1 shl (fd and 31)))<>0);
end;

procedure tlasin.release;
begin
  released := true;
end;

constructor tlasin.create;
begin
  inherited create;
  //writeln('tlsocket.create started');
  state := wsclosed;
  nextasin := firstasin;
  prevasin := nil;

  if assigned(nextasin) then nextasin.prevasin := self;
  firstasin := self;
  //writeln('tlsocket.create finished');
  released := false;
end;

destructor tlasin.destroy;
begin
  //writeln('tlsocket destroyed');
  if state <> wsclosed then close;
  if prevasin <> nil then begin
    prevasin.nextasin := nextasin;

  end else begin
    firstasin := nextasin;
  end;
  if nextasin <> nil then begin
    nextasin.prevasin := prevasin;
  end;
  inherited destroy;
end;

procedure tlasin.close;
begin
  internalclose(0);
end;


procedure tlasin.internalclose(error:word);
begin
  if state<>wsclosed then begin

    fcntl(s,F_SETFL,0);
    fdclose(s);
    state := wsclosed;
    //writeln('about to call onsessionclosed from tlsocket.close');

    if assigned(onsessionclosed) then onsessionclosed(self,error);
{    if not assigned(onsessionclosed) then debugout('onsessionclosed is not assigned');}
    //writeln('called onsessionclosed from tlsocket.close');

  end;
end;
procedure tlsocket.internalclose(error:word);
begin
  inherited internalclose(error);
  sendq := '';
end;

{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *}
{ All exceptions *MUST* be handled. If an exception is not handled, the     }
{ application will most likely be shut down !                               }
procedure Tlasin.HandleBackGroundException(E: Exception);
var
  CanAbort : Boolean;
begin
  CanAbort := TRUE;
  { First call the error event handler, if any }
  if Assigned(OnBgException) then begin
    try
      OnBgException(Self, E, CanAbort);
    except
    end;
  end;
  { Then abort the socket }
  if CanAbort then begin
    try
      close;
    except
    end;
  end;
end;

procedure tlsocket.connect;
begin
  //if state <> wsclosed then close;

  //prevtime := 0;
  host.namelookup(addr);
  // readln(a);
  //writeln(gettimeofday);
  inAddr.family:=AF_INET;
  { port 78 in network order }
  inAddr.port:=ShortHostToNet(strtointdef(port,0));
  { localhost : 127.0.0.1 in network order }
  inAddr.addr:=HostTonet(Longint(Host.IPAddress));
  s := Socket(AF_INET,SOCK_STREAM,0);
  if s = -1 then raise esocketexception.create('unable to create socket');
  dup(s);
  state :=wsconnecting;
  //if s > maxs then maxs := s;
  //writeln('about to connect');
  //fcntl(s,F_SETFL,OPEN_NONBLOCK);

  sockets.Connect(S,inADDR,sizeof(tsockaddr));
  //sendq := ''; // i now clear the sendq in close
  //writeln('tlsocket.connect complete');

end;

procedure tlsocket.sendstr(str : string);
begin
  putstringinsendbuffer(str);
  sendflush;
end;

procedure tlsocket.putstringinsendbuffer(newstring : string);
begin
  sendq := sendq + newstring;

end;

function tlsocket.sendflush : integer;
var
  lensent : integer;
begin
  if state <> wsconnected then exit;
  result := fdwrite(s,sendq[1],length(sendq));
  if result = -1 then lensent := 0 else lensent := result;
  if lensent = length(sendq) then begin
    sendq := '';
  end else begin
    sendq := copy(sendq,lensent+1,length(sendq)-lensent);
  end;
  fd_clr(s,fdsw);
end;

procedure tlsocket.dup(invalue:longint);
begin
  if state<> wsclosed then close;
  S := invalue;
  fcntl(s,F_SETFL,OPEN_NONBLOCK);
  if s > absoloutemaxs then raise esocketexception.create('file discriptor out of range');
  if s > maxs then maxs := s;
  state := wsconnected;

end;

procedure tlsocket.listen;
var
  yes:longint;
begin
  if state <> wsclosed then close;

  s := socket(AF_INET,SOCK_STREAM,0);
  if s = -1 then raise ESocketException .create('unable to create socket');
  dup(s); // sets up maxs among other things
  state := wsclosed; // then set this back as it was an undesired side effect of dup

  try
    yes := $1010101;  {Copied this from existing code. Value is empiric,
                    but works. (yes=true<>0) }
    if SetSocketOptions(s, SOL_SOCKET, SO_REUSEADDR,yes,sizeof(yes))=-1 then begin
      raise ESocketException.create('unable to set socket options');

    end;
    host.namelookup(addr);
    // readln(a);
    //writeln(gettimeofday);
    inAddr.family:=AF_INET;
    inAddr.port:=ShortHostToNet(strtointdef(port,0));
    inAddr.addr:=HostTonet(Longint(Host.IPAddress));
    if s > maxs then maxs := s;
    //writeln('about to connect');
    If Not Bind(S,inAddr,SizeOf(inAddr)) Then begin
      raise ESocketException.create('unable to bind');
    end;
    If Not sockets.Listen(S,5) Then raise esocketexception.create('unable to listen');
    state := wsListening;
  finally
    if state = wsclosed then begin
      fdclose(s); // we musnt leak file discriptors
    end;
  end;

end;

function tlsocket.accept : longint;
var
  FromAddrSize     : LongInt;        // i don't realy know what to do with these at this
  FromAddr         : TInetSockAddr;  // at this point time will tell :)

begin
  FromAddrSize := Sizeof(FromAddr);
  result := sockets.accept(s,fromaddr,fromaddrsize);
  if result = -1 then raise esocketexception.create('error '+inttostr(socketerror)+' while connecting');
end;

procedure messageloop;
var

  numread    : integer;
  currentsocket : tlasin;
  tempsocket : tlasin;
  socketcount : integer; // for debugging perposes :)
  sendflushresult : integer;
begin
  signal(sigpipe,signalhandler(sig_ign));
  {currentsocket := firstasin;
  if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed
  repeat

    if currentsocket.state = wsconnected then currentsocket.sendflush;
    currentsocket := currentsocket.nextasin;
  until not assigned(currentsocket);}



  repeat
    fd_zero(FDSR);
    fd_zero(FDSW);
    currentsocket := firstasin;
    if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed
    repeat
      if (not currentsocket.released) and (currentsocket.state<>wsclosed) then fd_set(currentsocket.s,fdsr);
      if (not currentsocket.released) and (currentsocket.state=wsconnecting) then fd_set(currentsocket.s,fdsw);
      if currentsocket is tlsocket then begin
         if (not currentsocket.released) and (currentsocket.state=wsconnected) and(tlsocket(currentsocket).sendq <> '') then fd_set(currentsocket.s,fdsw);
      end;
      tempsocket := currentsocket;
      currentsocket := currentsocket.nextasin;
      if tempsocket.released then begin
        tempsocket.free;
      end;
    until not assigned(currentsocket);

    debugout('about to call select');
    select(maxs+1,@FDSR,@FDSW,nil,1000);
    debugout('select complete');
    currentsocket := firstasin;
    if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed
    if gettimeofday <> prevtime then begin

      repeat

        if assigned(currentsocket.ontimer) then begin
          try
            currentsocket.ontimer;
          except
            on E: exception do begin
              currentsocket.HandleBackGroundException(e);
            end;
          end;
        end;

        tempsocket := currentsocket;
        currentsocket := currentsocket.nextasin;
        if tempsocket.released then begin
          tempsocket.free;
        end;
      until not assigned(currentsocket);
    end;
    //selecttext(sin,60000);
    prevtime := gettimeofday;



    currentsocket := firstasin;
    if not assigned(currentsocket) then exit; //the message loop will exit if all lsockets are destroyed
    socketcount := 0;
    repeat

      try
        if (currentsocket.state=wsconnected) and fd_isset(currentsocket.s,fdsw) and (currentsocket is tlsocket) then begin
          with tlsocket(currentsocket) do begin
            sendflushresult := sendflush;
            if sendflushresult <= 0 then begin
              if sendflushresult=0 then linuxerror := 0;
              currentsocket.internalclose(linuxerror);
            end;
          end;
        end;
        if (currentsocket.state =wslistening) and fd_isset(currentsocket.s,fdsr) then begin
          debugout('listening socket triggered on read');
          if assigned(currentsocket.onsessionAvailable) then currentsocket.onsessionAvailable(currentsocket,0);
        end;

        // the reason the read code is split in two is because the only way I
        // know of to check the results of a non-blocking connect when read has
        // been triggered is to read immidiately and look at the error the
        // on success the connected code falls through into the read code to
        // process the data it has read

        if (currentsocket.state =wsconnected) and fd_isset(currentsocket.s,fdsr) then begin
          debugout('connected socket triggered on read');
          setlength(currentsocket.receivestr,1024);
          numread := fdread(currentsocket.s,currentsocket.receivestr[1],1024);
          socketerror := linuxerror;
        end;
        if (currentsocket.state =wsconnecting) and fd_isset(currentsocket.s,fdsw) then begin
          // code for dealing with the reults of a non-blocking connect is
          // rather complex
          // if just write is triggered it means connect suceeded
          // if both read and write are suceededed it can mean 2 things
          // 1: connect ok and data availible
          // 2: connect fail
          // to find out which you must read from the socket and look for errors
          // there
          if not fd_isset(currentsocket.s,fdsr) then begin
            currentsocket.state := wsconnected;
            if assigned(currentsocket.onsessionconnected) then currentsocket.onsessionconnected(currentsocket,0);
          end else begin
            setlength(currentsocket.receivestr,1024);
            numread := fdread(currentsocket.s,currentsocket.receivestr[1],1024);
            socketerror := linuxerror;
            if numread <> -1 then begin
              currentsocket.state := wsconnected;
              if assigned(currentsocket.onsessionconnected) then currentsocket.onsessionconnected(currentsocket,0);
            end else begin
              currentsocket.state := wsclosed;
              if assigned(currentsocket.onsessionconnected) then currentsocket.onsessionconnected(currentsocket,socketerror);
              debugout('connect fail');
              fdclose(currentsocket.s);
            end;

            // if things went well here we are now in the state wsconnected with data sitting in our receive buffer
            // so we drop down into the processing for data availible
          end;
        end;
        if (currentsocket.state =wsconnected) and fd_isset(currentsocket.s,fdsr) then begin
          //writeln(numread);
          //writeln('blockread complete');
{          debugout(inttostr(numread));}
          if numread=0 then begin  // if i remember correctly numread=0 is caused by eof
                                   // if this isn't dealt with then you get a cpu eating infinite loop
{            debugout('calling close because of numread=0');}
            currentsocket.internalclose(0);
{            debugout('called close because of numread=0');}
          end;
          if (numread=-1) then begin
            numread := 0;
{             debugout(inttostr(socketerror)+' '+ inttostr(gettimeofday));}
            if (socketerror <> 0) and (socketerror <> SYS_EWOULDBLOCK) then begin
{              debugout('calling close because of a socketerror');}
              currentsocket.internalclose(socketerror);
{              debugout('called close because of a socketerror');}
            end;
          end;
          if numread > 0 then begin
            //parsecommand(false,tempstring);
            setlength(currentsocket.receivestr,numread);
            if assigned(currentsocket.ondataavailable) then currentsocket.ondataAvailable(currentsocket,0);
          end;
          //until (numread = 0) or (currentsocket.state<>wsconnected);
{          debugout('inner loop complete');}
        end;
      except
        on E: exception do begin
          currentsocket.HandleBackGroundException(e);

        end;
      end;
      tempsocket := currentsocket;
      currentsocket := currentsocket.nextasin;
      inc(socketcount);
      if tempsocket.released then begin
        tempsocket.free;
      end;
    until not assigned(currentsocket);
    debugout('socketcount='+inttostr(socketcount));
  until false;

end;
begin
  firstasin := nil;
  maxs := 0;
  prevtime :=0;
  //writeln('lsocket.pas initialised');
end.
